package com.jisco.dynamicweight.dynamicbasesender.controller;

import cn.hutool.core.lang.Assert;
import com.jisco.dynamicweight.dynamicbasereciever.model.DynamicBaseReciever;
import com.jisco.dynamicweight.util.ExcelUtil;
import com.jisco.dynamicweight.util.UserUtil;
import com.steerinfo.baseinfo.meterbasecalibrarelation.model.MeterBaseCalibraRelation;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.jisco.dynamicweight.dynamicbasesender.model.DynamicBaseSender;
import com.jisco.dynamicweight.dynamicbasesender.service.IDynamicBaseSenderService;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.*;
import java.math.BigDecimal;

/**
 * DynamicBaseSender RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-01-04 03:49
 * 类描述
 * 修订历史：
 * 日期：2022-01-04
 * 作者：generator
 * 参考：
 * 描述：DynamicBaseSender RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/dynamicbasesenders")
public class DynamicBaseSenderController extends BaseRESTfulController {

    @Autowired
    IDynamicBaseSenderService dynamicBaseSenderService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasesender:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<DynamicBaseSender> list = dynamicBaseSenderService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasesender:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<DynamicBaseSender> list = dynamicBaseSenderService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据DynamicBaseSender对象创建")
    @ApiImplicitParam(name = "dynamicBaseSender", value = "详细实体dynamicBaseSender", required = true, dataType = "DynamicBaseSender")
    //@RequiresPermissions("dynamicbasesender:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody DynamicBaseSender model){
        Assert.isTrue(StringUtils.isNotBlank(model.getSenderName()), "请输入PIKA系统发货单位名称！");
        Assert.isTrue(StringUtils.isNotBlank(model.getSenderCode()), "请输入PIKA系统发货单位编码！");
        Assert.isTrue(StringUtils.isNotBlank(model.getSenderType()), "请输入发货点类型！");
        Assert.isTrue(StringUtils.isNotBlank(model.getDisSysName()), "请输入分料系统名称！");
        Assert.isTrue(StringUtils.isNotBlank(model.getValidFlag()), "有效标识不能为空!");
        model.setCreateManNo(UserUtil.getCurrentUserId());
        model.setCreateManName(UserUtil.getCurrentUserName());
        model.setCreateTime(new Date());
        DynamicBaseSender dynamicBaseSender = dynamicBaseSenderService.add(model);
        return success(dynamicBaseSender);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasesender:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        DynamicBaseSender dynamicBaseSender = dynamicBaseSenderService.getById(id);
        return success(dynamicBaseSender);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的dynamicBaseSender信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "dynamicBaseSender", value = "详细实体dynamicBaseSender", required = true, dataType = "DynamicBaseSender")
    })
    //@RequiresPermissions("dynamicbasesender:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody DynamicBaseSender model){
        Assert.isTrue(StringUtils.isNotBlank(model.getSenderName()), "请输入PIKA系统发货单位名称！");
        Assert.isTrue(StringUtils.isNotBlank(model.getSenderCode()), "请输入PIKA系统发货单位编码！");
        Assert.isTrue(StringUtils.isNotBlank(model.getSenderType()), "请输入发货点类型！");
        Assert.isTrue(StringUtils.isNotBlank(model.getDisSysName()), "请输入分料系统名称！");
        Assert.isTrue(StringUtils.isNotBlank(model.getValidFlag()), "有效标识不能为空!");
        model.setId(id);
        model.setUpdateManNo(UserUtil.getCurrentUserId());
        model.setUpdateManName(UserUtil.getCurrentUserName());
        model.setUpdateTime(new Date());
        DynamicBaseSender dynamicBaseSender = dynamicBaseSenderService.modify(model);
        return success(dynamicBaseSender);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasesender:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  dynamicBaseSenderService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "导出Excel", notes = "导出Excel")
    @PostMapping(value = "/exportExcel")//String
    public void exportExcel(HttpServletResponse response) throws IOException {
        List<DynamicBaseSender> list = dynamicBaseSenderService.query(null);
        ExcelUtil.exportExcel(response, list, DynamicBaseSender.class, "发货单位信息");
    }

    @ApiOperation(value = "获取列表", notes = "不分页查询")
    @GetMapping(value = "/noPage")
    public RESTfulResult listall(@RequestParam HashMap parmas) {
        try {
            List<MeterBaseCalibraRelation> list = dynamicBaseSenderService.queryall(parmas);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "启用", notes = "启用")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    @GetMapping(value = "/enable/{id}")
    public RESTfulResult enable(@PathVariable String id) {
        boolean flag = dynamicBaseSenderService.enable(id);
        return flag ? success(null, "操作成功") : failed(null, "操作失败");
    }

    @ApiOperation(value = "禁用", notes = "禁用")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    @GetMapping(value = "/disable/{id}")
    public RESTfulResult disable(@PathVariable String id) {
        boolean flag = dynamicBaseSenderService.disable(id);
        return flag ? success(null, "操作成功") : failed(null, "操作失败");
    }
}
